{ File   : LBVVIEW.PAS
  Author : Deniz Oezmen
  Created: ~2001
  Changed: 2005-08-26

  The Lost Files of Sherlock Holmes: The Case of The Serrated Scalpel LBV
  viewer.
}
program HolmesLBVViewer;

uses
  GenSVGA,
  Graph;

type
  TColors = array[0..255] of record
                               R, G, B: Byte
                             end;

  TScrBuf = array[0..199, 0..319] of Byte;

var
  ScrBuf : ^TScrBuf;
  Exprt,
  Error  : Boolean;
  LBVFile: file;
  i      : Longint;
  Width,
  Height,
  x, y   : Word;
  Colors : TColors;

procedure SetRGB(C: Word; R, G, B: Byte); assembler;
asm
  mov ah, $10
  mov al, $10
  mov bx, c
  mov ch, g
  mov cl, b
  mov dh, r
  int $10
end;

begin
  if ParamCount > 0 then
  begin
    Assign(LBVFile, ParamStr(1));
    {$I-}
    Reset(LBVFile, 1);
    {$I+}
    if IOResult = 0 then
    begin
      SetVideo(320, 200, 256, Error);
      Seek(LBVFile, 20);
      BlockRead(LBVFile, Colors, sizeof(Colors));
      (* read Width/Height *)
      BlockRead(LBVFile, Width, 2);
      BlockRead(LBVFile, Height, 2);
      Inc(Width);
      Inc(Height);
      (* jump over 4 unknown bytes *)
      Seek(LBVFile, FilePos(LBVFile) + 4);
      for i := 0 to 255 do
        SetRGB(i, Colors[i].R, Colors[i].G, Colors[i].B);
      (* StartX bzw. StartY ignorieren *)
      New(ScrBuf);
      BlockRead(LBVFile, ScrBuf^, Width * Height);
      for y := 0 to 199 do
        for x := 0 to 319 do
           Mem[$a000:(y - 1) * 320 + x] := ScrBuf^[y, x];
      Close(LBVFile);
      Dispose(ScrBuf);
      ReadLn;
      VideoDeInit
    end
    else
      WriteLn('Couldn''t open file.')
  end
  else
  begin
    WriteLn('Holmes *.LBV picture viewer');
    WriteLn('(C)opyright Deniz Oezmen <deniz.oezmen@t-online.de>, 2001');
    WriteLn('Use at your own risk.');
    WriteLn;
    WriteLn('Usage: LBVVIEW.EXE <lbvfile>');
    WriteLn('       Press [ENTER] to exit the displayed picture.')
  end
end.