{ File   : RRMBGVIE.PAS
  Author : Deniz Oezmen
  Created: ~2001
  Changed: 2005-08-26

  The Lost Files of Sherlock Holmes: The Case of The Serrated Scalpel RRM
  background viewer.
}
program RRMBackgroundViewer;

uses
  VesaLib,
  Crt;

const
  Width  = 320;
  Height = 138;

type
  TColors = array[0..255] of record
                               R, G, B: Byte
                             end;

  TScrBuf = array[0..Height - 1, 0..Width - 1] of Byte;
  PScrBuf = ^TScrBuf;

var
  ScrBuf : PScrBuf;
  RRMFile: file;
  x, y   : Word;
  Colors : TColors;

procedure ReadPalette(var Colors: TColors);
var
  i: Byte;
begin
  BlockRead(RRMFile, Colors, SizeOf(Colors));

  for i := 0 to 255 do
    SetRGBPalette(i, Colors[i].R, Colors[i].G, Colors[i].B)
end;

procedure DrawBackground(ScrBuf: PScrBuf);
begin
  for y := 0 to Height - 1 do
    for x := 0 to Width - 1 do
       Mem[$a000:y * 320 + x] := ScrBuf^[y, x]
end;

begin
  if ParamCount <> 1 then
  begin
    WriteLn('Holmes *.RRM background viewer');
    WriteLn('(C)opyright Deniz Oezmen, 2001-2005');
    WriteLn('Use at your own risk.');
    WriteLn;
    WriteLn('Usage: RRMBGVIE <rrmfile>');
    WriteLn('       Press [ENTER] to exit the displayed picture.');
    Exit
  end;

  Assign(RRMFile, ParamStr(1));
  {$I-}
  Reset(RRMFile, 1);
  {$I+}

  if IOResult = 0 then
  begin
    SetupMode(_320x200x8bpp);

    Seek(RRMFile, FileSize(RRMFile) - Width * Height - SizeOf(Colors));

    ReadPalette(Colors);

    New(ScrBuf);
    BlockRead(RRMFile, ScrBuf^, Width * Height);

    DrawBackground(ScrBuf);

    Close(RRMFile);
    Dispose(ScrBuf);

    ReadLn;
    TextMode(co80)
  end
  else
    WriteLn('Couldn''t open file.')
end.